import numpy as np
import pandas as pd
import math
from Preprocessing import preprocess, get_sen_vectors
from sklearn.metrics.pairwise import cosine_similarity

def RC_Cos_Similarity(RC1, RC2):
    '''
    :param RC1, RC2: string type
    :return: int type
    '''
    RC1_vec = np.atleast_2d(get_sen_vectors('SO_w2v_200', preprocess(RC1)))
    RC2_vec = np.atleast_2d(get_sen_vectors('SO_w2v_200', preprocess(RC2)))
    Cos_Similarity = cosine_similarity(RC1_vec, RC2_vec).flatten('A')
    Cos_Similarity = float(Cos_Similarity)
    # print('Cosine Similarity:', Cos_Similarity)
    return Cos_Similarity


def jaccard_coefficient4text(RC1, RC2):
    '''
    :param RC1, RC2: string type
    :return: int type
    '''
    RC1_word = preprocess(RC1)
    RC2_word = preprocess(RC2)
    intersection_cardinality = len(set(RC1_word).intersection(set(RC2_word)))
    union_cardinality = len(set(RC1_word).union(set(RC2_word)))
    jaccard_similarity = intersection_cardinality / union_cardinality
    return jaccard_similarity


'''File Path Similarity: File Path'''
def hammingDistance4str(s1, s2):
    if s1 != s2:
        score = sum(el1 != el2 for el1, el2 in zip(s1, s2)) + math.fabs(len(s1)-len(s2))
        score = 1/ score
    else:
        score = 1
    return score

'''Jaccard similarity coefficient'''
def jaccard_coefficient4str(s1, s2):
    fp1 = s1.split("/")
    fp2 = s2.split("/")
    intersection_cardinality = len(set(fp1).intersection(set(fp2)))
    union_cardinality = len(set(fp1).union(set(fp2)))
    jaccard_coefficient = intersection_cardinality / union_cardinality
    return jaccard_coefficient